/**
 *******************************************************************************
 * @file    crc_calculatemodbus.c
 *
 * @brief   Implement system specific functions.
 *
 * @author  DP
 *
 * @version V1.0.0
 *
 * @date    2024-12-01
 *
 *******************************************************************************/

/*
    Copyright (c) 2024, DP Microelectronics Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

/* Files include */
#include "crc_calculatemodbus.h"

/**
  * @addtogroup DPM32M030_LibSamples
  * @{
  */

/**
  * @addtogroup demo
  * @{
  */

/**
  * @addtogroup demo 
  * @{
  */

/* Private typedef --------------------------------------------------------------*/
CRC_InitTypeStruct CRC_InitStruct;
/* Private define ---------------------------------------------------------------*/

/* Private macro ----------------------------------------------------------------*/

/* Private variables ------------------------------------------------------------*/
uint32_t CRCResult = 0;
/* Private functions ------------------------------------------------------------*/

/**
 *******************************************************************************
 * @brief   Demo Sample.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void CRC_CalculateModbus_Sample(void)
{
  UART0_Init();
  
    /* Enable clock */
  RCC_Unlock();
  RCC_APBPeriphClockCmd(RCC_APB_PERIPH_CRC, ENABLE);
  RCC_Lock();
  /* Config CRC */
  CRC_DeInit();
  CRC_StructInit(&CRC_InitStruct);
  CRC_InitStruct.CRC_InitValue = 0xFFFF;
  CRC_InitStruct.CRC_Mode = CRC_MODE_CRC16_8005;
  CRC_InitStruct.CRC_InputRevType = CRC_INPUT_REV_16BITS;
  CRC_InitStruct.CRC_OutputRevType = CRC_OUTPUT_REV_YES;
  CRC_InitStruct.CRC_OutputXorType = CRC_OUTPUT_XOR_ALL0;
  CRC_Init(&CRC_InitStruct);
  /* Get result */
  CRCResult = CRC_CalcCRC16bits(0x1234);
  
  printf("CRCResult = %d \r\n",CRCResult);
}

/**
 *******************************************************************************
 * @brief   Demo Sample.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void UART0_Init(void)
{
  RCC_Unlock();
  RCC_APBPeriphClockCmd(RCC_APB_PERIPH_UART0, ENABLE);
  RCC_AHBPeriphClockCmd(RCC_AHB_PERIPH_GPIO, ENABLE);
  RCC_Lock();
  
  UART_InitTypeStruct UART_InitType;
  GPIO_InitTypeStruct GPIO_InitStruct;
  
  GPIO_InitStruct.GPIO_Pin = GPIO_PIN_9 | GPIO_PIN_10;
  GPIO_InitStruct.GPIO_Mode = GPIO_MODE_ALT_FUNC;
  GPIO_InitStruct.GPIO_Speed = GPIO_SPEED_HIGH;
  GPIO_InitStruct.GPIO_OType = GPIO_OTYPE_PP;
  GPIO_InitStruct.GPIO_PuPd = GPIO_PUPD_NOPULL;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_AltFuncConfig(GPIOA, GPIO_PIN_9 |  GPIO_PIN_10, GPIO_ALT_FUNC_1);

  UART_StructInit(&UART_InitType);
  UART_Init(UART0, &UART_InitType);
  UART_Cmd(UART0, ENABLE);
}
int fputc(int ch, FILE *f)
{

  while((UART0->ISR & UART_ISR_TXE_Msk) == 0);

  UART0->TDR = ch;

  return ch;
}

/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT DP *****END OF FILE ***************************/
